]> git.ipfire.org Git - ipfire-2.x.git/blame_incremental - make.sh
make.sh: Fix position of SKIP message when building packages
[ipfire-2.x.git] / make.sh
... / ...
CommitLineData
1#!/bin/bash
2############################################################################
3# #
4# This file is part of the IPFire Firewall. #
5# #
6# IPFire is free software; you can redistribute it and/or modify #
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
11# IPFire is distributed in the hope that it will be useful, #
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
17# along with IPFire; if not, write to the Free Software #
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
20# Copyright (C) 2007-2017 IPFire Team <info@ipfire.org>. #
21# #
22############################################################################
23#
24
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
27VERSION="2.19" # Version number
28CORE="117" # Core Level (Filename)
29PAKFIRE_CORE="116" # Core Level (PAKFIRE)
30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
35BUILD_IMAGES=1 # Flash and Xen Downloader
36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
39
40TOOLCHAINVER=20171121
41
42###############################################################################
43#
44# Beautifying variables & presentation & input output interface
45#
46###############################################################################
47
48# Remember if the shell is interactive or not
49if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51else
52 INTERACTIVE=false
53fi
54
55# Sets or adjusts pretty formatting variables
56resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
65
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
73 TIME_COL=$(( COLUMNS - TIME_WIDTH - STATUS_WIDTH ))
74 STATUS_COL=$(( COLUMNS - STATUS_WIDTH ))
75}
76
77# Initially setup terminal
78resize_terminal
79
80# Call resize_terminal when terminal is being resized
81trap "resize_terminal" WINCH
82
83# Define color for messages
84BOLD="\\033[1;39m"
85DONE="\\033[1;32m"
86SKIP="\\033[1;34m"
87WARN="\\033[1;35m"
88FAIL="\\033[1;31m"
89NORMAL="\\033[0;39m"
90
91# New architecture variables
92HOST_ARCH="$(uname -m)"
93
94PWD=$(pwd)
95BASENAME=$(basename $0)
96
97# Debian specific settings
98if [ ! -e /etc/debian_version ]; then
99 FULLPATH=`which $0`
100else
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
107fi
108
109# This is the directory where make.sh is in
110export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
111
112LOGFILE=$BASEDIR/log/_build.preparation.log
113export LOGFILE
114DIR_CHK=$BASEDIR/cache/check
115mkdir $BASEDIR/log/ 2>/dev/null
116
117system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119}
120
121system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133}
134
135configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
147 CFLAGS_ARCH="-m64 -mtune=generic"
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
154 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
161 CFLAGS_ARCH=""
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4"
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
211 local cpu_max=$(( ${processors} * 2 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
220 MAKETUNING="-j${parallelism}"
221 fi
222}
223
224configure_build_guess() {
225 case "${HOST_ARCH}" in
226 x86_64|i686|i586)
227 echo "i586"
228 ;;
229
230 aarch64)
231 echo "aarch64"
232 ;;
233
234 armv7*|armv6*|armv5*)
235 echo "armv5tel"
236 ;;
237
238 *)
239 exiterror "Cannot guess build architecture"
240 ;;
241 esac
242}
243
244stdumount() {
245 umount $BASEDIR/build/sys 2>/dev/null;
246 umount $BASEDIR/build/dev/shm 2>/dev/null;
247 umount $BASEDIR/build/dev/pts 2>/dev/null;
248 umount $BASEDIR/build/dev 2>/dev/null;
249 umount $BASEDIR/build/proc 2>/dev/null;
250 umount $BASEDIR/build/install/mnt 2>/dev/null;
251 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
252 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
253 umount $BASEDIR/build/usr/src/config 2>/dev/null;
254 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
255 umount $BASEDIR/build/usr/src/html 2>/dev/null;
256 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
257 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
258 umount $BASEDIR/build/usr/src/log 2>/dev/null;
259 umount $BASEDIR/build/usr/src/src 2>/dev/null;
260}
261
262now() {
263 date -u "+%s"
264}
265
266format_runtime() {
267 local seconds=${1}
268
269 if [ ${seconds} -ge 3600 ]; then
270 printf "%d:%02d:%02d\n" \
271 "$(( seconds / 3600 ))" \
272 "$(( seconds % 3600 / 60 ))" \
273 "$(( seconds % 3600 % 60 ))"
274 elif [ ${seconds} -ge 60 ]; then
275 printf "%d:%02d\n" \
276 "$(( seconds / 60 ))" \
277 "$(( seconds % 60 ))"
278 else
279 printf "%d\n" "${seconds}"
280 fi
281}
282
283print_line() {
284 local line="$@"
285
286 printf "%-${LINE_WIDTH}s" "${line}"
287}
288
289_print_line() {
290 local status="${1}"
291 shift
292
293 if ${INTERACTIVE}; then
294 printf "${!status}"
295 fi
296
297 print_line "$@"
298
299 if ${INTERACTIVE}; then
300 printf "${NORMAL}"
301 fi
302}
303
304print_headline() {
305 _print_line BOLD "$@"
306}
307
308print_error() {
309 _print_line FAIL "$@"
310}
311
312print_package() {
313 local name="${1}"
314 shift
315
316 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
317 local options="$@"
318
319 local string="${name}"
320 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
321 string="${string} (${version})"
322 fi
323
324 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
325
326 if [ -n "${options}" ]; then
327 printf "[ %-$(( ${OPTIONS_WIDTH} - 4 ))s ]" "${options}"
328 else
329 printf "%${OPTIONS_WIDTH}s" ""
330 fi
331}
332
333print_runtime() {
334 local runtime=$(format_runtime $@)
335
336 if ${INTERACTIVE}; then
337 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
338 else
339 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
340 fi
341}
342
343print_status() {
344 local status="${1}"
345
346 local color="${!status}"
347
348 if ${INTERACTIVE}; then
349 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
350 else
351 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
352 fi
353}
354
355print_build_stage() {
356 print_headline "$@"
357
358 # end line
359 printf "\n"
360}
361
362print_build_summary() {
363 local runtime=$(format_runtime $@)
364
365 print_line "*** Build finished in ${runtime}"
366 print_status DONE
367}
368
369exiterror() {
370 stdumount
371 for i in `seq 0 7`; do
372 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
373 losetup -d /dev/loop${i} 2>/dev/null
374 fi;
375 done
376
377 # Dump logfile
378 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
379 echo # empty line
380
381 local line
382 while read -r line; do
383 echo " ${line}"
384 done <<< "$(tail -n30 ${LOGFILE})"
385 fi
386
387 echo # empty line
388
389 local line
390 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
391 print_error "${line}"
392 print_status FAIL
393 done
394
395 exit 1
396}
397
398prepareenv() {
399 # Are we running the right shell?
400 if [ -z "${BASH}" ]; then
401 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
402 fi
403
404 if [ -z "${BASH_VERSION}" ]; then
405 exiterror "Not running BASH shell."
406 fi
407
408 # Trap on emergency exit
409 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
410
411 # Resetting our nice level
412 if ! renice ${NICE} $$ >/dev/null; then
413 exiterror "Failed to set nice level to ${NICE}"
414 fi
415
416 # Checking if running as root user
417 if [ $(id -u) -ne 0 ]; then
418 exiterror "Not building as root"
419 fi
420
421 # Checking for necessary temporary space
422 print_line "Checking for necessary space on disk $BASE_DEV"
423 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
424 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
425 if (( 2048000 > $BASE_ASPACE )); then
426 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
427 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
428 print_status FAIL
429 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
430 fi
431 else
432 print_status DONE
433 fi
434
435 # Set umask
436 umask 022
437
438 # Set LFS Directory
439 LFS=$BASEDIR/build
440
441 # Check ${TOOLS_DIR} symlink
442 if [ -h "${TOOLS_DIR}" ]; then
443 rm -f "${TOOLS_DIR}"
444 fi
445
446 if [ ! -e "${TOOLS_DIR}" ]; then
447 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
448 fi
449
450 if [ ! -h "${TOOLS_DIR}" ]; then
451 exiterror "Could not create ${TOOLS_DIR} symbolic link"
452 fi
453
454 # Setup environment
455 set +h
456 LC_ALL=POSIX
457 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
458 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
459
460 # Make some extra directories
461 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
462 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
463 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
464 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
465 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
466
467 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
468 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
469
470 # Make all sources and proc available under lfs build
471 mount --bind /dev $BASEDIR/build/dev
472 mount --bind /dev/pts $BASEDIR/build/dev/pts
473 mount --bind /dev/shm $BASEDIR/build/dev/shm
474 mount --bind /proc $BASEDIR/build/proc
475 mount --bind /sys $BASEDIR/build/sys
476 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
477 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
478 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
479 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
480 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
481 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
482 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
483 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
484 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
485
486 # Run LFS static binary creation scripts one by one
487 export CCACHE_DIR=$BASEDIR/ccache
488 export CCACHE_COMPRESS=1
489 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
490
491 # Remove pre-install list of installed files in case user erase some files before rebuild
492 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
493
494 # Prepare string for /etc/system-release.
495 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
496 if [ "$(git status -s | wc -l)" == "0" ]; then
497 GIT_STATUS=""
498 else
499 GIT_STATUS="-dirty"
500 fi
501 case "$GIT_BRANCH" in
502 core*|beta?|rc?)
503 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
504 ;;
505 *)
506 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
507 ;;
508 esac
509}
510
511enterchroot() {
512 # Install QEMU helper, if needed
513 qemu_install_helper
514
515 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
516
517 PATH="${PATH}" chroot ${LFS} env -i \
518 HOME="/root" \
519 TERM="${TERM}" \
520 PS1="${PS1}" \
521 PATH="${PATH}" \
522 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
523 PAKFIRE_CORE="${PAKFIRE_CORE}" \
524 NAME="${NAME}" \
525 SNAME="${SNAME}" \
526 VERSION="${VERSION}" \
527 CORE="${CORE}" \
528 SLOGAN="${SLOGAN}" \
529 TOOLS_DIR="${TOOLS_DIR}" \
530 CONFIG_ROOT="${CONFIG_ROOT}" \
531 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
532 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
533 BUILDTARGET="${BUILDTARGET}" \
534 CROSSTARGET="${CROSSTARGET}" \
535 BUILD_ARCH="${BUILD_ARCH}" \
536 BUILD_PLATFORM="${BUILD_PLATFORM}" \
537 CCACHE_DIR=/usr/src/ccache \
538 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
539 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
540 KVER="${KVER}" \
541 $(fake_environ) \
542 $(qemu_environ) \
543 "$@"
544}
545
546entershell() {
547 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
548 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
549 fi
550
551 echo "Entering to a shell inside LFS chroot, go out with exit"
552 local PS1="ipfire build chroot ($(uname -m)) \u:\w\$ "
553
554 if enterchroot bash -i; then
555 stdumount
556 else
557 print_status FAIL
558 exiterror "chroot error"
559 fi
560}
561
562lfsmakecommoncheck() {
563 # Script present?
564 if [ ! -f $BASEDIR/lfs/$1 ]; then
565 exiterror "No such file or directory: $BASEDIR/$1"
566 fi
567
568 # Print package name and version
569 print_package $@
570
571 # Check if this package is supported by our architecture.
572 # If no SUP_ARCH is found, we assume the package can be built for all.
573 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
574 # Check if package supports ${BUILD_ARCH} or all architectures.
575 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
576 print_runtime 0
577 print_status SKIP
578 return 1
579 fi
580 fi
581
582 # Script slipped?
583 local i
584 for i in $SKIP_PACKAGE_LIST
585 do
586 if [ "$i" == "$1" ]; then
587 print_status SKIP
588 return 1;
589 fi
590 done
591
592 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
593
594 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
595 MESSAGE="$1\t " download >> $LOGFILE 2>&1
596 if [ $? -ne 0 ]; then
597 exiterror "Download error in $1"
598 fi
599
600 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
601 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
602 if [ $? -ne 0 ]; then
603 exiterror "md5sum error in $1, check file in cache or signature"
604 fi
605
606 return 0 # pass all!
607}
608
609lfsmake1() {
610 lfsmakecommoncheck $*
611 [ $? == 1 ] && return 0
612
613 cd $BASEDIR/lfs && env -i \
614 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
615 CCACHE_DIR="${CCACHE_DIR}" \
616 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
617 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
618 CFLAGS="${CFLAGS}" \
619 CXXFLAGS="${CXXFLAGS}" \
620 MAKETUNING="${MAKETUNING}" \
621 make -f $* \
622 TOOLCHAIN=1 \
623 TOOLS_DIR="${TOOLS_DIR}" \
624 CROSSTARGET="${CROSSTARGET}" \
625 BUILDTARGET="${BUILDTARGET}" \
626 BUILD_ARCH="${BUILD_ARCH}" \
627 BUILD_PLATFORM="${BUILD_PLATFORM}" \
628 LFS_BASEDIR="${BASEDIR}" \
629 ROOT="${LFS}" \
630 KVER="${KVER}" \
631 install >> $LOGFILE 2>&1 &
632
633 if ! wait_until_finished $!; then
634 print_status FAIL
635 exiterror "Building $*"
636 fi
637
638 print_status DONE
639}
640
641lfsmake2() {
642 lfsmakecommoncheck $*
643 [ $? == 1 ] && return 0
644
645 local PS1='\u:\w$ '
646
647 enterchroot \
648 bash -x -c "cd /usr/src/lfs && \
649 MAKETUNING=${MAKETUNING} \
650 make -f $* \
651 LFS_BASEDIR=/usr/src install" \
652 >> ${LOGFILE} 2>&1 &
653
654 if ! wait_until_finished $!; then
655 print_status FAIL
656 exiterror "Building $*"
657 fi
658
659 print_status DONE
660}
661
662ipfiredist() {
663 lfsmakecommoncheck $*
664 [ $? == 1 ] && return 0
665
666 local PS1='\u:\w$ '
667
668 enterchroot \
669 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
670 >> ${LOGFILE} 2>&1 &
671
672 if ! wait_until_finished $!; then
673 print_status FAIL
674 exiterror "Packaging $*"
675 fi
676
677 print_status DONE
678}
679
680wait_until_finished() {
681 local pid=${1}
682
683 local start_time=$(now)
684
685 # Show progress
686 if ${INTERACTIVE}; then
687 # Wait a little just in case the process
688 # has finished very quickly.
689 sleep 0.1
690
691 local runtime
692 while kill -0 ${pid} 2>/dev/null; do
693 print_runtime $(( $(now) - ${start_time} ))
694
695 # Wait a little
696 sleep 1
697 done
698 fi
699
700 # Returns the exit code of the child process
701 wait ${pid}
702 local ret=$?
703
704 if ! ${INTERACTIVE}; then
705 print_runtime $(( $(now) - ${start_time} ))
706 fi
707
708 return ${ret}
709}
710
711fake_environ() {
712 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
713
714 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
715
716 # Fake kernel version, because some of the packages do not compile
717 # with kernel 3.0 and later.
718 env="${env} UTS_RELEASE=${KVER}"
719
720 # Fake machine version.
721 env="${env} UTS_MACHINE=${BUILD_ARCH}"
722
723 echo "${env}"
724}
725
726qemu_environ() {
727 local env
728
729 # Don't add anything if qemu is not used.
730 if ! qemu_is_required; then
731 return
732 fi
733
734 # Set default qemu options
735 case "${BUILD_ARCH}" in
736 arm*)
737 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
738
739 env="${env} QEMU_CPU=${QEMU_CPU}"
740 ;;
741 esac
742
743 # Enable QEMU strace
744 #env="${env} QEMU_STRACE=1"
745
746 echo "${env}"
747}
748
749qemu_is_required() {
750 local build_arch="${1}"
751
752 if [ -z "${build_arch}" ]; then
753 build_arch="${BUILD_ARCH}"
754 fi
755
756 case "${HOST_ARCH},${build_arch}" in
757 x86_64,arm*|i?86,arm*|i?86,x86_64)
758 return 0
759 ;;
760 *)
761 return 1
762 ;;
763 esac
764}
765
766qemu_install_helper() {
767 # Do nothing, if qemu is not required
768 if ! qemu_is_required; then
769 return 0
770 fi
771
772 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
773 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
774 fi
775
776 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
777 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
778 fi
779
780
781 if [ -z "${QEMU_TARGET_HELPER}" ]; then
782 exiterror "QEMU_TARGET_HELPER not set"
783 fi
784
785 # Check if the helper is already installed.
786 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
787 return 0
788 fi
789
790 # Try to find a suitable binary that we can install
791 # to the build environment.
792 local file
793 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
794 # file must exist and be executable.
795 [ -x "${file}" ] || continue
796
797 # Must be static.
798 file_is_static "${file}" || continue
799
800 local dirname="${LFS}$(dirname "${file}")"
801 mkdir -p "${dirname}"
802
803 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
804 return 0
805 done
806
807 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
808}
809
810qemu_find_build_helper_name() {
811 local build_arch="${1}"
812
813 local magic
814 case "${build_arch}" in
815 arm*)
816 magic="7f454c4601010100000000000000000002002800"
817 ;;
818 x86_64)
819 magic="7f454c4602010100000000000000000002003e00"
820 ;;
821 esac
822
823 [ -z "${magic}" ] && return 1
824
825 local file
826 for file in /proc/sys/fs/binfmt_misc/*; do
827 # skip write only register entry
828 [ $(basename "${file}") = "register" ] && continue
829 # Search for the file with the correct magic value.
830 grep -qE "^magic ${magic}$" "${file}" || continue
831
832 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
833
834 [ -n "${interpreter}" ] || continue
835 [ "${interpreter:0:1}" = "/" ] || continue
836 [ -x "${interpreter}" ] || continue
837
838 echo "${interpreter}"
839 return 0
840 done
841
842 return 1
843}
844
845file_is_static() {
846 local file="${1}"
847
848 file ${file} 2>/dev/null | grep -q "statically linked"
849}
850
851update_language_list() {
852 local path="${1}"
853
854 local lang
855 for lang in ${path}/*.po; do
856 lang="$(basename "${lang}")"
857 echo "${lang%*.po}"
858 done | sort -u > "${path}/LINGUAS"
859}
860
861# Load configuration file
862if [ -f .config ]; then
863 . .config
864fi
865
866# TARGET_ARCH is BUILD_ARCH now
867if [ -n "${TARGET_ARCH}" ]; then
868 BUILD_ARCH="${TARGET_ARCH}"
869 unset TARGET_ARCH
870fi
871
872# Get the amount of memory in this build system
873HOST_MEM=$(system_memory)
874
875if [ -n "${BUILD_ARCH}" ]; then
876 configure_build "${BUILD_ARCH}"
877else
878 configure_build "default"
879fi
880
881buildtoolchain() {
882 local error=false
883 case "${BUILD_ARCH}:${HOST_ARCH}" in
884 # x86_64
885 x86_64:x86_64)
886 # This is working.
887 ;;
888
889 # x86
890 i586:i586|i586:i686|i586:x86_64)
891 # These are working.
892 ;;
893 i586:*)
894 error=true
895 ;;
896
897 # ARM
898 arvm7hl:armv7hl|armv7hl:armv7l)
899 # These are working.
900 ;;
901
902 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
903 # These are working.
904 ;;
905 armv5tel:*)
906 error=true
907 ;;
908 esac
909
910 ${error} && \
911 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
912
913 local gcc=$(type -p gcc)
914 if [ -z "${gcc}" ]; then
915 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
916 fi
917
918 LOGFILE="$BASEDIR/log/_build.toolchain.log"
919 export LOGFILE
920
921 lfsmake1 stage1
922 lfsmake1 ccache PASS=1
923 lfsmake1 binutils PASS=1
924 lfsmake1 gcc PASS=1
925 lfsmake1 linux KCFG="-headers"
926 lfsmake1 glibc
927 lfsmake1 gcc PASS=L
928 lfsmake1 binutils PASS=2
929 lfsmake1 gcc PASS=2
930 lfsmake1 ccache PASS=2
931 lfsmake1 tcl
932 lfsmake1 expect
933 lfsmake1 dejagnu
934 lfsmake1 pkg-config
935 lfsmake1 ncurses
936 lfsmake1 bash
937 lfsmake1 bzip2
938 lfsmake1 automake
939 lfsmake1 coreutils
940 lfsmake1 diffutils
941 lfsmake1 findutils
942 lfsmake1 gawk
943 lfsmake1 gettext
944 lfsmake1 grep
945 lfsmake1 gzip
946 lfsmake1 m4
947 lfsmake1 make
948 lfsmake1 patch
949 lfsmake1 perl
950 lfsmake1 sed
951 lfsmake1 tar
952 lfsmake1 texinfo
953 lfsmake1 xz
954 lfsmake1 fake-environ
955 lfsmake1 cleanup-toolchain
956}
957
958buildbase() {
959 LOGFILE="$BASEDIR/log/_build.base.log"
960 export LOGFILE
961 lfsmake2 stage2
962 lfsmake2 linux KCFG="-headers"
963 lfsmake2 man-pages
964 lfsmake2 glibc
965 lfsmake2 tzdata
966 lfsmake2 cleanup-toolchain
967 lfsmake2 zlib
968 lfsmake2 binutils
969 lfsmake2 gmp
970 lfsmake2 gmp-compat
971 lfsmake2 mpfr
972 lfsmake2 libmpc
973 lfsmake2 file
974 lfsmake2 gcc
975 lfsmake2 sed
976 lfsmake2 autoconf
977 lfsmake2 automake
978 lfsmake2 berkeley
979 lfsmake2 coreutils
980 lfsmake2 iana-etc
981 lfsmake2 m4
982 lfsmake2 bison
983 lfsmake2 ncurses-compat
984 lfsmake2 ncurses
985 lfsmake2 procps
986 lfsmake2 libtool
987 lfsmake2 perl
988 lfsmake2 readline
989 lfsmake2 readline-compat
990 lfsmake2 bzip2
991 lfsmake2 pcre
992 lfsmake2 pcre-compat
993 lfsmake2 bash
994 lfsmake2 diffutils
995 lfsmake2 e2fsprogs
996 lfsmake2 ed
997 lfsmake2 findutils
998 lfsmake2 flex
999 lfsmake2 gawk
1000 lfsmake2 gettext
1001 lfsmake2 grep
1002 lfsmake2 groff
1003 lfsmake2 gperf
1004 lfsmake2 gzip
1005 lfsmake2 hostname
1006 lfsmake2 iproute2
1007 lfsmake2 jwhois
1008 lfsmake2 kbd
1009 lfsmake2 less
1010 lfsmake2 make
1011 lfsmake2 man
1012 lfsmake2 kmod
1013 lfsmake2 net-tools
1014 lfsmake2 patch
1015 lfsmake2 psmisc
1016 lfsmake2 shadow
1017 lfsmake2 sysklogd
1018 lfsmake2 sysvinit
1019 lfsmake2 tar
1020 lfsmake2 texinfo
1021 lfsmake2 util-linux
1022 lfsmake2 udev
1023 lfsmake2 vim
1024 lfsmake2 xz
1025 lfsmake2 paxctl
1026}
1027
1028buildipfire() {
1029 LOGFILE="$BASEDIR/log/_build.ipfire.log"
1030 export LOGFILE
1031 lfsmake2 configroot
1032 lfsmake2 initscripts
1033 lfsmake2 backup
1034 lfsmake2 pkg-config
1035 lfsmake2 libusb
1036 lfsmake2 libusb-compat
1037 lfsmake2 libpcap
1038 lfsmake2 ppp
1039 lfsmake2 pptp
1040 lfsmake2 unzip
1041 lfsmake2 which
1042 lfsmake2 linux-firmware
1043 lfsmake2 ath10k-firmware
1044 lfsmake2 dvb-firmwares
1045 lfsmake2 mt7601u-firmware
1046 lfsmake2 zd1211-firmware
1047 lfsmake2 rpi-firmware
1048 lfsmake2 bc
1049 lfsmake2 u-boot
1050 lfsmake2 cpio
1051 lfsmake2 mdadm
1052 lfsmake2 dracut
1053 lfsmake2 lvm2
1054 lfsmake2 multipath-tools
1055 lfsmake2 freetype
1056 lfsmake2 grub
1057 lfsmake2 libmnl
1058 lfsmake2 libnfnetlink
1059 lfsmake2 libnetfilter_queue
1060 lfsmake2 libnetfilter_conntrack
1061 lfsmake2 libnetfilter_cthelper
1062 lfsmake2 libnetfilter_cttimeout
1063 lfsmake2 iptables
1064
1065 case "${BUILD_ARCH}" in
1066 x86_64)
1067 lfsmake2 linux KCFG=""
1068 lfsmake2 backports KCFG=""
1069 lfsmake2 e1000e KCFG=""
1070 lfsmake2 igb KCFG=""
1071 lfsmake2 ixgbe KCFG=""
1072 lfsmake2 xtables-addons KCFG=""
1073 lfsmake2 linux-initrd KCFG=""
1074 ;;
1075 i586)
1076 # x86-pae (Native and new XEN) kernel build
1077 lfsmake2 linux KCFG="-pae"
1078 lfsmake2 backports KCFG="-pae"
1079 lfsmake2 e1000e KCFG="-pae"
1080 lfsmake2 igb KCFG="-pae"
1081 lfsmake2 ixgbe KCFG="-pae"
1082 lfsmake2 xtables-addons KCFG="-pae"
1083 lfsmake2 linux-initrd KCFG="-pae"
1084
1085 # x86 kernel build
1086 lfsmake2 linux KCFG=""
1087 lfsmake2 backports KCFG=""
1088 lfsmake2 e1000e KCFG=""
1089 lfsmake2 igb KCFG=""
1090 lfsmake2 ixgbe KCFG=""
1091 lfsmake2 xtables-addons KCFG=""
1092 lfsmake2 linux-initrd KCFG=""
1093 ;;
1094
1095 armv5tel)
1096 # arm-rpi (Raspberry Pi) kernel build
1097 lfsmake2 linux KCFG="-rpi"
1098 lfsmake2 backports KCFG="-rpi"
1099 lfsmake2 xtables-addons KCFG="-rpi"
1100 lfsmake2 linux-initrd KCFG="-rpi"
1101
1102 # arm multi platform (Panda, Wandboard ...) kernel build
1103 lfsmake2 linux KCFG="-multi"
1104 lfsmake2 backports KCFG="-multi"
1105 lfsmake2 e1000e KCFG="-multi"
1106 lfsmake2 igb KCFG="-multi"
1107 lfsmake2 ixgbe KCFG="-multi"
1108 lfsmake2 xtables-addons KCFG="-multi"
1109 lfsmake2 linux-initrd KCFG="-multi"
1110
1111 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
1112 lfsmake2 linux KCFG="-kirkwood"
1113 lfsmake2 backports KCFG="-kirkwood"
1114 lfsmake2 e1000e KCFG="-kirkwood"
1115 lfsmake2 igb KCFG="-kirkwood"
1116 lfsmake2 ixgbe KCFG="-kirkwood"
1117 lfsmake2 xtables-addons KCFG="-kirkwood"
1118 lfsmake2 linux-initrd KCFG="-kirkwood"
1119 ;;
1120 esac
1121 lfsmake2 xtables-addons USPACE="1"
1122 lfsmake2 openssl
1123 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1124 lfsmake2 libgpg-error
1125 lfsmake2 libgcrypt
1126 lfsmake2 libassuan
1127 lfsmake2 nettle
1128 lfsmake2 libevent
1129 lfsmake2 libevent2
1130 lfsmake2 libevent2-compat
1131 lfsmake2 expat
1132 lfsmake2 apr
1133 lfsmake2 aprutil
1134 lfsmake2 unbound
1135 lfsmake2 gnutls
1136 lfsmake2 bind
1137 lfsmake2 dhcp
1138 lfsmake2 dhcpcd
1139 lfsmake2 boost
1140 lfsmake2 linux-atm
1141 lfsmake2 gdbm
1142 lfsmake2 pam
1143 lfsmake2 curl
1144 lfsmake2 tcl
1145 lfsmake2 sqlite
1146 lfsmake2 libffi
1147 lfsmake2 python
1148 lfsmake2 python3
1149 lfsmake2 ca-certificates
1150 lfsmake2 fireinfo
1151 lfsmake2 libnet
1152 lfsmake2 libnl
1153 lfsmake2 libnl-3
1154 lfsmake2 libidn
1155 lfsmake2 nasm
1156 lfsmake2 libjpeg
1157 lfsmake2 libjpeg-compat
1158 lfsmake2 libexif
1159 lfsmake2 libpng
1160 lfsmake2 libtiff
1161 lfsmake2 libart
1162 lfsmake2 gd
1163 lfsmake2 popt
1164 lfsmake2 slang
1165 lfsmake2 newt
1166 lfsmake2 libsmooth
1167 lfsmake2 attr
1168 lfsmake2 acl
1169 lfsmake2 libcap
1170 lfsmake2 pciutils
1171 lfsmake2 usbutils
1172 lfsmake2 libxml2
1173 lfsmake2 libxslt
1174 lfsmake2 BerkeleyDB
1175 lfsmake2 mysql
1176 lfsmake2 cyrus-sasl
1177 lfsmake2 openldap
1178 lfsmake2 apache2
1179 lfsmake2 php
1180 lfsmake2 web-user-interface
1181 lfsmake2 flag-icons
1182 lfsmake2 jquery
1183 lfsmake2 bootstrap
1184 lfsmake2 arping
1185 lfsmake2 beep
1186 lfsmake2 dvdrtools
1187 lfsmake2 dosfstools
1188 lfsmake2 reiserfsprogs
1189 lfsmake2 xfsprogs
1190 lfsmake2 sysfsutils
1191 lfsmake2 fuse
1192 lfsmake2 ntfs-3g
1193 lfsmake2 ethtool
1194 lfsmake2 ez-ipupdate
1195 lfsmake2 fcron
1196 lfsmake2 perl-GD
1197 lfsmake2 GD-Graph
1198 lfsmake2 GD-TextUtil
1199 lfsmake2 perl-Device-SerialPort
1200 lfsmake2 perl-Device-Modem
1201 lfsmake2 perl-Apache-Htpasswd
1202 lfsmake2 gnupg
1203 lfsmake2 hdparm
1204 lfsmake2 sdparm
1205 lfsmake2 mtools
1206 lfsmake2 whatmask
1207 lfsmake2 conntrack-tools
1208 lfsmake2 libupnp
1209 lfsmake2 ipaddr
1210 lfsmake2 iputils
1211 lfsmake2 l7-protocols
1212 lfsmake2 mISDNuser
1213 lfsmake2 capi4k-utils
1214 lfsmake2 hwdata
1215 lfsmake2 logrotate
1216 lfsmake2 logwatch
1217 lfsmake2 misc-progs
1218 lfsmake2 nano
1219 lfsmake2 URI
1220 lfsmake2 HTML-Tagset
1221 lfsmake2 HTML-Parser
1222 lfsmake2 HTML-Template
1223 lfsmake2 Compress-Zlib
1224 lfsmake2 Digest
1225 lfsmake2 Digest-SHA1
1226 lfsmake2 Digest-HMAC
1227 lfsmake2 libwww-perl
1228 lfsmake2 Net-DNS
1229 lfsmake2 Net-IPv4Addr
1230 lfsmake2 Net_SSLeay
1231 lfsmake2 IO-Stringy
1232 lfsmake2 IO-Socket-SSL
1233 lfsmake2 Unix-Syslog
1234 lfsmake2 Mail-Tools
1235 lfsmake2 MIME-Tools
1236 lfsmake2 Net-Server
1237 lfsmake2 Convert-TNEF
1238 lfsmake2 Convert-UUlib
1239 lfsmake2 Archive-Tar
1240 lfsmake2 Archive-Zip
1241 lfsmake2 Text-Tabs+Wrap
1242 lfsmake2 Locale-Country
1243 lfsmake2 XML-Parser
1244 lfsmake2 Crypt-PasswdMD5
1245 lfsmake2 Net-Telnet
1246 lfsmake2 python-setuptools
1247 lfsmake2 python-clientform
1248 lfsmake2 python-mechanize
1249 lfsmake2 python-feedparser
1250 lfsmake2 python-rssdler
1251 lfsmake2 python-inotify
1252 lfsmake2 python-docutils
1253 lfsmake2 python-daemon
1254 lfsmake2 python-ipaddress
1255 lfsmake2 glib
1256 lfsmake2 GeoIP
1257 lfsmake2 noip_updater
1258 lfsmake2 ntp
1259 lfsmake2 openssh
1260 lfsmake2 fontconfig
1261 lfsmake2 dejavu-fonts-ttf
1262 lfsmake2 ubuntu-font-family
1263 lfsmake2 freefont
1264 lfsmake2 pixman
1265 lfsmake2 cairo
1266 lfsmake2 pango
1267 lfsmake2 rrdtool
1268 lfsmake2 setserial
1269 lfsmake2 setup
1270 lfsmake2 libdnet
1271 lfsmake2 daq
1272 lfsmake2 snort
1273 lfsmake2 oinkmaster
1274 lfsmake2 squid
1275 lfsmake2 squidguard
1276 lfsmake2 calamaris
1277 lfsmake2 tcpdump
1278 lfsmake2 traceroute
1279 lfsmake2 vlan
1280 lfsmake2 wireless
1281 lfsmake2 pakfire
1282 lfsmake2 spandsp
1283 lfsmake2 lzo
1284 lfsmake2 openvpn
1285 lfsmake2 pammysql
1286 lfsmake2 mpage
1287 lfsmake2 dbus
1288 lfsmake2 intltool
1289 lfsmake2 libdaemon
1290 lfsmake2 cups
1291 lfsmake2 lcms2
1292 lfsmake2 ghostscript
1293 lfsmake2 qpdf
1294 lfsmake2 poppler
1295 lfsmake2 cups-filters
1296 lfsmake2 epson-inkjet-printer-escpr
1297 lfsmake2 foomatic
1298 lfsmake2 hplip
1299 lfsmake2 cifs-utils
1300 lfsmake2 krb5
1301 lfsmake2 samba
1302 lfsmake2 sudo
1303 lfsmake2 mc
1304 lfsmake2 wget
1305 lfsmake2 bridge-utils
1306 lfsmake2 screen
1307 lfsmake2 smartmontools
1308 lfsmake2 htop
1309 lfsmake2 chkconfig
1310 lfsmake2 postfix
1311 lfsmake2 fetchmail
1312 lfsmake2 cyrus-imapd
1313 lfsmake2 openmailadmin
1314 lfsmake2 clamav
1315 lfsmake2 spamassassin
1316 lfsmake2 amavisd
1317 lfsmake2 dma
1318 lfsmake2 alsa
1319 lfsmake2 mpfire
1320 lfsmake2 guardian
1321 lfsmake2 libid3tag
1322 lfsmake2 libmad
1323 lfsmake2 libogg
1324 lfsmake2 libvorbis
1325 lfsmake2 libdvbpsi
1326 lfsmake2 flac
1327 lfsmake2 lame
1328 lfsmake2 sox
1329 lfsmake2 libshout
1330 lfsmake2 xvid
1331 lfsmake2 libmpeg2
1332 lfsmake2 libarchive
1333 lfsmake2 cmake
1334 lfsmake2 gnump3d
1335 lfsmake2 rsync
1336 lfsmake2 tcpwrapper
1337 lfsmake2 libtirpc
1338 lfsmake2 rpcbind
1339 lfsmake2 nfs
1340 lfsmake2 gnu-netcat
1341 lfsmake2 ncat
1342 lfsmake2 nmap
1343 lfsmake2 etherwake
1344 lfsmake2 bwm-ng
1345 lfsmake2 sysstat
1346 lfsmake2 strongswan
1347 lfsmake2 rng-tools
1348 lfsmake2 lsof
1349 lfsmake2 br2684ctl
1350 lfsmake2 pcmciautils
1351 lfsmake2 lm_sensors
1352 lfsmake2 liboping
1353 lfsmake2 collectd
1354 lfsmake2 elinks
1355 lfsmake2 igmpproxy
1356 lfsmake2 fbset
1357 lfsmake2 opus
1358 lfsmake2 python-six
1359 lfsmake2 python-pyparsing
1360 lfsmake2 spice-protocol
1361 lfsmake2 spice
1362 lfsmake2 sdl
1363 lfsmake2 libusbredir
1364 lfsmake2 qemu
1365 lfsmake2 sane
1366 lfsmake2 netpbm
1367 lfsmake2 phpSANE
1368 lfsmake2 tunctl
1369 lfsmake2 netsnmpd
1370 lfsmake2 nagios
1371 lfsmake2 nagios_nrpe
1372 lfsmake2 icinga
1373 lfsmake2 ebtables
1374 lfsmake2 directfb
1375 lfsmake2 faad2
1376 lfsmake2 ffmpeg
1377 lfsmake2 vdr
1378 lfsmake2 vdr_streamdev
1379 lfsmake2 vdr_epgsearch
1380 lfsmake2 vdr_dvbapi
1381 lfsmake2 vdr_eepg
1382 lfsmake2 w_scan
1383 lfsmake2 icecast
1384 lfsmake2 icegenerator
1385 lfsmake2 mpd
1386 lfsmake2 libmpdclient
1387 lfsmake2 mpc
1388 lfsmake2 perl-Net-SMTP-SSL
1389 lfsmake2 perl-MIME-Base64
1390 lfsmake2 perl-Authen-SASL
1391 lfsmake2 perl-MIME-Lite
1392 lfsmake2 perl-Email-Date-Format
1393 lfsmake2 git
1394 lfsmake2 squidclamav
1395 lfsmake2 vnstat
1396 lfsmake2 iw
1397 lfsmake2 wpa_supplicant
1398 lfsmake2 hostapd
1399 lfsmake2 pycurl
1400 lfsmake2 urlgrabber
1401 lfsmake2 syslinux
1402 lfsmake2 tftpd
1403 lfsmake2 cpufrequtils
1404 lfsmake2 bluetooth
1405 lfsmake2 gutenprint
1406 lfsmake2 apcupsd
1407 lfsmake2 iperf
1408 lfsmake2 iperf3
1409 lfsmake2 7zip
1410 lfsmake2 lynis
1411 lfsmake2 streamripper
1412 lfsmake2 sshfs
1413 lfsmake2 taglib
1414 #lfsmake2 mediatomb
1415 lfsmake2 sslh
1416 lfsmake2 perl-gettext
1417 lfsmake2 perl-Sort-Naturally
1418 lfsmake2 vdradmin
1419 lfsmake2 miau
1420 lfsmake2 perl-DBI
1421 lfsmake2 perl-DBD-mysql
1422 lfsmake2 perl-DBD-SQLite
1423 lfsmake2 perl-File-ReadBackwards
1424 lfsmake2 cacti
1425 lfsmake2 openvmtools
1426 lfsmake2 nagiosql
1427 lfsmake2 motion
1428 lfsmake2 joe
1429 lfsmake2 monit
1430 lfsmake2 nut
1431 lfsmake2 watchdog
1432 lfsmake2 libpri
1433 lfsmake2 libsrtp
1434 lfsmake2 asterisk
1435 lfsmake2 lcr
1436 lfsmake2 usb_modeswitch
1437 lfsmake2 usb_modeswitch_data
1438 lfsmake2 zerofree
1439 lfsmake2 minicom
1440 lfsmake2 ddrescue
1441 lfsmake2 miniupnpd
1442 lfsmake2 client175
1443 lfsmake2 powertop
1444 lfsmake2 parted
1445 lfsmake2 swig
1446 lfsmake2 python-m2crypto
1447 lfsmake2 wireless-regdb
1448 lfsmake2 crda
1449 lfsmake2 libsolv
1450 lfsmake2 python-distutils-extra
1451 lfsmake2 python-lzma
1452 lfsmake2 python-progressbar
1453 lfsmake2 python-xattr
1454 lfsmake2 ddns
1455 lfsmake2 transmission
1456 lfsmake2 dpfhack
1457 lfsmake2 lcd4linux
1458 lfsmake2 mtr
1459 lfsmake2 minidlna
1460 lfsmake2 acpid
1461 lfsmake2 fping
1462 lfsmake2 telnet
1463 lfsmake2 xinetd
1464 lfsmake2 gpgme
1465 lfsmake2 pygpgme
1466 lfsmake2 pakfire3
1467 lfsmake2 stress
1468 lfsmake2 libstatgrab
1469 lfsmake2 sarg
1470 lfsmake2 check_mk_agent
1471 lfsmake2 nginx
1472 lfsmake2 sendEmail
1473 lfsmake2 sysbench
1474 lfsmake2 strace
1475 lfsmake2 elfutils
1476 lfsmake2 ltrace
1477 lfsmake2 ipfire-netboot
1478 lfsmake2 lcdproc
1479 lfsmake2 bitstream
1480 lfsmake2 multicat
1481 lfsmake2 keepalived
1482 lfsmake2 ipvsadm
1483 lfsmake2 perl-Carp-Clan
1484 lfsmake2 perl-Date-Calc
1485 lfsmake2 perl-Date-Manip
1486 lfsmake2 perl-File-Tail
1487 lfsmake2 perl-TimeDate
1488 lfsmake2 swatch
1489 lfsmake2 tor
1490 lfsmake2 arm
1491 lfsmake2 wavemon
1492 lfsmake2 iptraf-ng
1493 lfsmake2 iotop
1494 lfsmake2 stunnel
1495 lfsmake2 owncloud
1496 lfsmake2 bacula
1497 lfsmake2 batctl
1498 lfsmake2 perl-Font-TTF
1499 lfsmake2 perl-IO-String
1500 lfsmake2 perl-PDF-API2
1501 lfsmake2 squid-accounting
1502 lfsmake2 pigz
1503 lfsmake2 tmux
1504 lfsmake2 perl-Text-CSV_XS
1505 lfsmake2 swconfig
1506 lfsmake2 haproxy
1507 lfsmake2 ipset
1508 lfsmake2 lua
1509 lfsmake2 dnsdist
1510 lfsmake2 bird
1511 lfsmake2 dmidecode
1512 lfsmake2 mcelog
1513 lfsmake2 rtpproxy
1514 lfsmake2 util-macros
1515 lfsmake2 libpciaccess
1516 lfsmake2 libyajl
1517 lfsmake2 libvirt
1518 lfsmake2 python3-libvirt
1519 lfsmake2 freeradius
1520 lfsmake2 perl-common-sense
1521 lfsmake2 perl-inotify2
1522 lfsmake2 perl-Net-IP
1523 lfsmake2 wio
1524 lfsmake2 iftop
1525}
1526
1527buildinstaller() {
1528 # Run installer scripts one by one
1529 LOGFILE="$BASEDIR/log/_build.installer.log"
1530 export LOGFILE
1531 lfsmake2 memtest
1532 lfsmake2 installer
1533 lfsmake1 strip
1534}
1535
1536buildpackages() {
1537 LOGFILE="$BASEDIR/log/_build.packages.log"
1538 export LOGFILE
1539 echo "... see detailed log in _build.*.log files" >> $LOGFILE
1540
1541
1542 # Generating list of packages used
1543 print_line "Generating packages list from logs"
1544 rm -f $BASEDIR/doc/packages-list
1545 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1546 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
1547 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
1548 fi
1549 done
1550 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
1551 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
1552 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1553 rm -f $BASEDIR/doc/packages-list
1554 # packages-list.txt is ready to be displayed for wiki page
1555 print_status DONE
1556
1557 # Update changelog
1558 cd $BASEDIR
1559 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1560 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1561 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
1562
1563 # Create images for install
1564 lfsmake2 cdrom
1565
1566 # Check if there is a loop device for building in virtual environments
1567 modprobe loop 2>/dev/null
1568 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
1569 lfsmake2 flash-images
1570 lfsmake2 flash-images SCON=1
1571 fi
1572
1573 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
1574
1575 ipfirepackages
1576
1577 lfsmake2 xen-image
1578 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
1579
1580 cd $BASEDIR
1581
1582 # remove not useable iso on armv5tel (needed to build flash images)
1583 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
1584
1585 for i in `ls *.bz2 *.img.gz *.iso`; do
1586 md5sum $i > $i.md5
1587 done
1588 cd $PWD
1589
1590 # Cleanup
1591 stdumount
1592 rm -rf $BASEDIR/build/tmp/*
1593
1594 cd $PWD
1595}
1596
1597ipfirepackages() {
1598 lfsmake2 core-updates
1599
1600 local i
1601 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
1602 i=$(basename ${i})
1603 if [ -e $BASEDIR/lfs/$i ]; then
1604 ipfiredist $i
1605 else
1606 echo -n $i
1607 print_status SKIP
1608 fi
1609 done
1610 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
1611 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
1612 rm -rf $BASEDIR/build/install/packages/*
1613}
1614
1615while [ $# -gt 0 ]; do
1616 case "${1}" in
1617 --target=*)
1618 configure_build "${1#--target=}"
1619 ;;
1620 -*)
1621 exiterror "Unknown configuration option: ${1}"
1622 ;;
1623 *)
1624 # Found a command, so exit options parsing.
1625 break
1626 ;;
1627 esac
1628 shift
1629done
1630
1631# See what we're supposed to do
1632case "$1" in
1633build)
1634 START_TIME=$(now)
1635
1636 # Clear screen
1637 ${INTERACTIVE} && clear
1638
1639 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
1640 #only restore on a clean disk
1641 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
1642 if [ ! -n "$PACKAGE" ]; then
1643 print_build_stage "Full toolchain compilation"
1644 prepareenv
1645 buildtoolchain
1646 else
1647 PACKAGENAME=${PACKAGE%.tar.xz}
1648 print_build_stage "Packaged toolchain compilation"
1649 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
1650 tar axf $PACKAGE
1651 prepareenv
1652 else
1653 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1654 fi
1655 fi
1656 else
1657 prepareenv
1658 fi
1659
1660 print_build_stage "Building LFS"
1661 buildbase
1662
1663 print_build_stage "Building IPFire"
1664 buildipfire
1665
1666 print_build_stage "Building installer"
1667 buildinstaller
1668
1669 print_build_stage "Building packages"
1670 buildpackages
1671
1672 print_build_stage "Checking Logfiles for new Files"
1673
1674 cd $BASEDIR
1675 tools/checknewlog.pl
1676 tools/checkrootfiles
1677 cd $PWD
1678
1679 print_build_summary $(( $(now) - ${START_TIME} ))
1680 ;;
1681shell)
1682 # enter a shell inside LFS chroot
1683 # may be used to changed kernel settings
1684 prepareenv
1685 entershell
1686 ;;
1687clean)
1688 print_line "Cleaning build directory..."
1689
1690 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1691 $LOSETUP -d $i 2>/dev/null
1692 done
1693 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1694 umount $i
1695 done
1696 stdumount
1697 for i in `seq 0 7`; do
1698 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
1699 umount /dev/loop${i} 2>/dev/null;
1700 losetup -d /dev/loop${i} 2>/dev/null;
1701 fi;
1702 done
1703 rm -rf $BASEDIR/build
1704 rm -rf $BASEDIR/cdrom
1705 rm -rf $BASEDIR/packages
1706 rm -rf $BASEDIR/log
1707 if [ -h "${TOOLS_DIR}" ]; then
1708 rm -f "${TOOLS_DIR}"
1709 fi
1710 rm -f $BASEDIR/ipfire-*
1711 print_status DONE
1712 ;;
1713downloadsrc)
1714 if [ ! -d $BASEDIR/cache ]; then
1715 mkdir $BASEDIR/cache
1716 fi
1717 mkdir -p $BASEDIR/log
1718 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
1719 FINISHED=0
1720 cd $BASEDIR/lfs
1721 for c in `seq $MAX_RETRIES`; do
1722 if (( FINISHED==1 )); then
1723 break
1724 fi
1725 FINISHED=1
1726 cd $BASEDIR/lfs
1727 for i in *; do
1728 if [ -f "$i" -a "$i" != "Config" ]; then
1729 lfsmakecommoncheck ${i} || continue
1730
1731 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1732 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
1733 if [ $? -ne 0 ]; then
1734 print_status FAIL
1735 FINISHED=0
1736 else
1737 if [ $c -eq 1 ]; then
1738 print_status DONE
1739 fi
1740 fi
1741 fi
1742 done
1743 done
1744 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
1745 ERROR=0
1746 for i in *; do
1747 if [ -f "$i" -a "$i" != "Config" ]; then
1748 lfsmakecommoncheck ${i} > /dev/null || continue
1749 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
1750 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
1751 if [ $? -ne 0 ]; then
1752 echo -ne "MD5 difference in lfs/$i"
1753 print_status FAIL
1754 ERROR=1
1755 fi
1756 fi
1757 done
1758 if [ $ERROR -eq 0 ]; then
1759 echo -ne "${BOLD}all files md5sum match${NORMAL}"
1760 print_status DONE
1761 else
1762 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
1763 print_status FAIL
1764 fi
1765 cd - >/dev/null 2>&1
1766 ;;
1767toolchain)
1768 # Clear screen
1769 ${INTERACTIVE} && clear
1770
1771 prepareenv
1772 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
1773 buildtoolchain
1774 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1775 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1776 cd $BASEDIR && XZ_OPT="-T0 -8" tar -Jc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1777 build/${TOOLS_DIR} build/bin/sh log >> $LOGFILE
1778 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
1779 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
1780 stdumount
1781 ;;
1782gettoolchain)
1783 # arbitrary name to be updated in case of new toolchain package upload
1784 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
1785 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
1786 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
1787 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
1788 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
1789 cd $BASEDIR/cache/toolchains
1790 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
1791 if [ $? -ne 0 ]; then
1792 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
1793 else
1794 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
1795 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1796 else
1797 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1798 fi
1799 fi
1800 else
1801 echo "Toolchain is already downloaded. Exiting..."
1802 fi
1803 ;;
1804uploadsrc)
1805 PWD=`pwd`
1806 if [ -z $IPFIRE_USER ]; then
1807 echo -n "You have to setup IPFIRE_USER first. See .config for details."
1808 print_status FAIL
1809 exit 1
1810 fi
1811
1812 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
1813 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
1814
1815 for file in ${BASEDIR}/cache/*; do
1816 [ -d "${file}" ] && continue
1817 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
1818 NEW_FILES="$NEW_FILES $file"
1819 done
1820 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1821 cd $BASEDIR
1822 cd $PWD
1823 exit 0
1824 ;;
1825lang)
1826 echo -ne "Checking the translations for missing or obsolete strings..."
1827 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1828 $BASEDIR/tools/sort_strings.pl en
1829 $BASEDIR/tools/sort_strings.pl de
1830 $BASEDIR/tools/sort_strings.pl fr
1831 $BASEDIR/tools/sort_strings.pl es
1832 $BASEDIR/tools/sort_strings.pl pl
1833 $BASEDIR/tools/sort_strings.pl ru
1834 $BASEDIR/tools/sort_strings.pl nl
1835 $BASEDIR/tools/sort_strings.pl tr
1836 $BASEDIR/tools/sort_strings.pl it
1837 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1838 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1839 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1840 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1841 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1842 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1843 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1844 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1845 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1846 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
1847 print_status DONE
1848
1849 echo -ne "Updating language lists..."
1850 update_language_list ${BASEDIR}/src/installer/po
1851 update_language_list ${BASEDIR}/src/setup/po
1852 print_status DONE
1853 ;;
1854*)
1855 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1856 cat doc/make.sh-usage
1857 ;;
1858esac